<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/TR/REC-html40"> 
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>fwAccessControl_Export.pnl 
panel</title>
<link rel="StyleSheet" HREF="style.css" TYPE="text/css" MEDIA="screen,print">
</head>
<body>
<table width="95%" border="1"><tbody>
<tr vAlign="top">
<td width="22%" bgColor="#00cc00"><strong>Panel Name</strong></td>
<td width="78%" colSpan="2">fwAccessControl/fwAccessControl_Export.pnl</td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Introduction<br></strong></td>
<td colSpan="2">
<p>Export Access Control data panel</p>
<p> 
<p>
    This panel is used to export the Access Control data: domains, groups and users definitions.
    It is considered as a helper tool for developers who need to distribute certain elements
    of the access control data, namely the definition of domains and privileges, with their
    code.<br>
    The panel is presented in Figure 1.
    <div xmlns:html="http://www.w3.org/1999/xhtml" class="figure"><table align="center">
<tr><td><img src="fwAccessControl_Export.png"></td></tr>
<tr><td><span class="caption">Figure 1: The Export panel</span></td></tr>
</table></div>
</p>

<h3> Selecting the objects to export </h3>
<p>
The main part of the panel is made of two lists: the list on the left allows to select
the domains, groups, or users to be added; the right list contains the objects that are
chosen for export. A set of buttons between the two list allow to move the items between the lists,
hence add or remove objects from the <em>Selected Object</em> list on the right.
The objects on the right list will be exported when the  <span class="button">OK</span> button is pressed.
</p>
<p>
To add an object to a list of selected ones, choose the type of the object: "Domains", "Groups" or "Users"
in the combo-box above the left list, then select the name(s) of the object (note that you may select
multiple objects if you hold CTRL key while clicking on the items), then press the <span class="button">&gt;</span>.
The objects will appear in the list on the right, and will be greyed-out in the list on the left. <br>
To remove the objects from the right list, click on them and press the <span class="button">&lt;</span> button. <br>
You may use the <span class="button">&gt;&gt;</span> and <span class="button">&lt;&lt;</span> buttons to move all items between the lists;
</p>

<h3> Dependency resolving</h3>
<p>
The panel contains the mechanism which assures that the data being exported is coherent and complete.
For every imported user it checks if all  groups, to which the users belong, are also exported;
for every exported group it checks if all domains in which the group has access rights are exported. 
This consistency checking is performed on the list of objects currently selected for export
(present in the rightside list), when the <span class="button">OK</span> button is pressed. If any of dependencies
is unresolved, the <a href="fwAccessControl_LogWindow.htm">Log Window</a>  with the
list of dependencies is displayed, asking whether the objects which are needed to fulfill the dependencies
should be added to selection; accepting this results in these objects being appended to the rightside list.
Only if all dependencies are fulfilled, the actual export may go on.<br>
The dependency checking (and resolving) mechanism may be disabled by unselecting the 
<em> Enforce consistency</em> checkbox. When the checkbox is off, the dependency checking mechanism
will not be employed, and clicking the <span class="button">OK</span> button will export the list of objects being 
currently on the rightside list.
</p>
</p>
<br>
</td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Instructions</strong></td>
<td colSpan="2"><dl>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To package the definition of domain(s) into a component:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
    If you develop panels that makes use of Access Control, 
    <ul>
	<li> Open this panel using the <span class="button">Export</span> button in the
	    <a href="fwAccessControl_Setup.htm">Setup</a>  panel.
	</li>
	<li> In the file-chooser, navigate to the directory where you want to place the
	    exported file, and type in the name for the file. To make it compatible with
	    the Framework Component Installation/Packager tool, you should put the file
	    in the <code>scripts</code> directory of your project, and give
	    it the name with the <code>.postInstall</code> extension.
	</li>
	<li> In the export panel, select the domain(s) you need to export; use
	<span class="button">&gt;</span> button to put selected domains on the rightside list.<br>
	We discourage exporting groups and users into a <em>.postInstall</em> file.
	It is the task of your system integrator to define groups and users, and grant the privileges,
	then distribute the users and groups definitions using the Access Control Server.
	However if you insist on exporting groups and users for the reasons of convenience of
	your coworkers, please make sure that dependencies are resolved.
	</li>
	<li> Use the component packager tool to add the <em>.postInstall</em> file
	to your component; add the requirement on <em>fwAccessControl 2.5.0</em> component.<br> 
	Alternatively, edit the component's XML file and add line such as:
	<code> &lt;postInstall&gt;scripts/MyComponent/MyComponentAC.postInstall&lt;postInstall&gt;</code> , and
	<code> &lt;required&gt;fwAccessControl=2.5.0&lt;/required&gt;</code>
	<br>
	Remember to include the <em>.postInstall</em> file in the list of files you distribute.
	</li>
    </ul>
</dd>
</dl></td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Restrictions</strong></td>
<td colSpan="2"><ul><li xmlns:html="http://www.w3.org/1999/xhtml"> If called directly, the panel will not save the data to any file - it
will return the lines of code as a return value (see the <em>Return Values from panel</em>
section below.<br>
It is therefore recommended to use the <span class="button">Export</span> button in the
<a href="fwAccessControl_Setup.htm">Setup</a>  panel, which actually displays the export panel,
then saves the data to a file (the path and name of which may be selected);
it also "enriches" the exported lines of code
in such a way that the exported file is ready to be run in a CTRL Manager, or as a part of a 
<em>postInstall</em> script of the Framework Component Installation Tool.
</li></ul></td>
</tr>
</tbody></table>
<br>
<table width="95%" border="1"><tbody>
<tr bgColor="#00cc00"><td colSpan="3"><strong>Return Values from panel</strong></td></tr>
<tr><td colspan="3"> The panel should be opened using functions from the
	<code>ChildPanel...Returns(... , df,ds)</code> family. <br>
	When the panel is closed the following values may be returned in the
	<code>df</code> and <code>ds</code> parameters:
    </td></tr>
<tr bgColor="#00cc00">
<td width="60"><strong>Variable</strong></td>
<td width="10%"><strong>Value(s)</strong></td>
<td><strong>Description</strong></td>
</tr>
<tr bgColor="#ccffcc"><td colspan="3" align="center">
<code>dyn_float</code>  parameter (<code>df[]</code>)</td></tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>df[1]</code></td>
<td><code>1</code></td>
<td> <span class="button">OK</span> button was pressed and export operations were succesfull</td>
</tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>df[1]</code></td>
<td><code>0</code></td>
<td> <span class="button">Cancel</span> button was pressed or an error was encountered</td>
</tr>
<tr bgColor="#ccffcc"><td colspan="3" align="center">
<code>dyn_string</code> parameter (<code>ds[]</code>)</td></tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>ds[]</code></td>
<td><code></code></td>
<td> contains the lines of the code (in PVSS scripting language), that may be embedded into a script, 
    and used to import the access control data.
    The code defines the <code>void postInstall_fwAccessControl(dyn_string &amp;exceptionInfo)</code>
    function.<br> 
    Typically, the code has a form similar to presented in the following example:
<pre>
void postInstall_fwAccessControl(dyn_string &amp;exceptionInfo)
{
string acComponent="fwAccessControl";
string acVersion="2.5.0";
int acInstalled;
fwInstallation_componentInstalled(acComponent, acVersion, acInstalled);
if (!acInstalled) { makeDynString(exceptionInfo,"ERROR","Access Control component "+
		    acVersion+" not installed","");return;};

if (!dynlen(exceptionInfo)) fwAccessControl_checkAddDomain("MyDCS",
		 makeDynString("Monitor Me","Control","Debug Him","Modify"),
		 exceptionInfo,
		 "MyDCS controls",
		 "MyDCS control system");

if (!dynlen(exceptionInfo)) fwAccessControl_checkAddGroup("DCSOperators",
		 makeDynString("SYSTEM:Visualize","MyDCS:Monitor","MyDCS:Debug","MyDCS:Control"),
		 exceptionInfo,
		 "DCS Opeators",
		 "A group of DCS shift operators");

if (!dynlen(exceptionInfo)) fwAccessControl_checkAddUser("joe",
		 makeDynString("DCSOperators"),
		 exceptionInfo,
		 "Joe, the Operator",
		 "tel. XXXXX",
		 "xxxxxxxxxxx",
		 4096,
		 TRUE);

}
</pre>
</td>
</tr>
</tbody></table>
<br><a href="../../fwAccessControl.htm">
Back to the documentation of the
	    fwAccessControl
component.
	    </a> <br xmlns:html="http://www.w3.org/1999/xhtml"><hr xmlns:html="http://www.w3.org/1999/xhtml">
<font xmlns:html="http://www.w3.org/1999/xhtml" size="-1"> Piotr Golonka, <a href="http://cern.ch/itcobe">CERN IT/CO-BE</a></font>
</body></html>
